{ File   : BBB.pas
  Author : Deniz Oezmen
  Created: 2007-03-12
  Changed: 2007-03-20

  The Longest Journey BBB wrapper unit.
}
unit BBB;

interface

type
  TBBBCallback = procedure(const Frac: Double);

function CopyBBB(const BBBName, BIKName: string;
  const BBBCallback: TBBBCallback): Boolean;

implementation

uses
  TLJ_FS,
  SysUtils;

function CopyBBB(const BBBName, BIKName: string;
  const BBBCallback: TBBBCallback): Boolean;
const
  BufSize = 1048576;
var
  BBBFile     : TFS_Handle;
  BIKFile     : file;
  BytesRead,
  BytesWritten: Longint;
  Buffer      : array of Byte;
begin
  Result := False;

  if not FS_OpenFile(BBBName, BBBFile) then
    Exit;

  FileMode := fmOpenReadWrite;  
  AssignFile(BIKFile, BIKName);
  {$I-}
  Rewrite(BIKFile, 1);
  {$I+}
  if IOResult <> 0 then
  begin
    FS_CloseFile(BBBFile);
    Exit
  end;

  SetLength(Buffer, BufSize);

  while not FS_Eof(BBBFile) do
  begin
    BytesRead := FS_BlockRead(BBBFile, Buffer[0], BufSize);
    if (BytesRead < BufSize) and not FS_Eof(BBBFile) then
    begin
      Finalize(Buffer);
      FS_CloseFile(BBBFile);
      CloseFile(BIKFile);
      Exit
    end;

    BlockWrite(BIKFile, Buffer[0], BytesRead, BytesWritten);
    if BytesWritten < BytesRead then
    begin
      Finalize(Buffer);
      FS_CloseFile(BBBFile);
      CloseFile(BIKFile);
      Exit
    end;

    BBBCallback(FS_FilePos(BBBFile) / FS_FileSize(BBBFile))
  end;

  Finalize(Buffer);
  FS_CloseFile(BBBFile);
  CloseFile(BIKFile);

  Result := True
end;

end.
