{ File   : OVS.pas
  Author : Deniz Oezmen
  Created: 2006-09-01
  Changed: 2007-03-20

  The Longest Journey OVS wrapper unit.
}
unit OVS;

interface

type
  TOVSCallback = procedure(const Frac: Double);

function CopyOVS(const OVSName, OGGName: string;
  const OVSCallback: TOVSCallback): Boolean;

implementation

uses
  TLJ_FS,
  SysUtils;

function CopyOVS(const OVSName, OGGName: string;
  const OVSCallback: TOVSCallback): Boolean;
const
  BufSize = 1048576;
var
  OVSFile     : TFS_Handle;
  OGGFile     : file;
  BytesRead,
  BytesWritten: Longint;
  Buffer      : array of Byte;
begin
  Result := False;

  if not FS_OpenFile(OVSName, OVSFile) then
    Exit;

  FileMode := fmOpenReadWrite;
  AssignFile(OGGFile, OGGName);
  {$I-}
  Rewrite(OGGFile, 1);
  {$I+}
  if IOResult <> 0 then
  begin
    FS_CloseFile(OVSFile);
    Exit
  end;

  SetLength(Buffer, BufSize);

  while not FS_Eof(OVSFile) do
  begin
    BytesRead := FS_BlockRead(OVSFile, Buffer[0], BufSize);
    if (BytesRead < BufSize) and not FS_Eof(OVSFile) then
    begin
      Finalize(Buffer);
      FS_CloseFile(OVSFile);
      CloseFile(OGGFile);
      Exit
    end;

    BlockWrite(OGGFile, Buffer[0], BytesRead, BytesWritten);
    if BytesWritten < BytesRead then
    begin
      Finalize(Buffer);
      FS_CloseFile(OVSFile);
      CloseFile(OGGFile);
      Exit
    end;

    OVSCallback(FS_FilePos(OVSFile) / FS_FileSize(OVSFile))
  end;

  Finalize(Buffer);
  FS_CloseFile(OVSFile);
  CloseFile(OGGFile);

  Result := True
end;

end.
