{ File   : SSS.pas
  Author : Deniz Oezmen
  Created: 2007-03-12
  Changed: 2007-03-20

  The Longest Journey SSS wrapper unit.
}
unit SSS;

interface

type
  TSSSCallback = procedure(const Frac: Double);

function CopySSS(const SSSName, SMKName: string;
  const SSSCallback: TSSSCallback): Boolean;

implementation

uses
  TLJ_FS,
  SysUtils;

function CopySSS(const SSSName, SMKName: string;
  const SSSCallback: TSSSCallback): Boolean;
const
  BufSize = 1048576;
var
  SSSFile     : TFS_Handle;
  SMKFile     : file;
  BytesRead,
  BytesWritten: Longint;
  Buffer      : array of Byte;
begin
  Result := False;

  if not FS_OpenFile(SSSName, SSSFile) then
    Exit;

  FileMode := fmOpenReadWrite;
  AssignFile(SMKFile, SMKName);
  {$I-}
  Rewrite(SMKFile, 1);
  {$I+}
  if IOResult <> 0 then
  begin
    FS_CloseFile(SSSFile);
    Exit
  end;

  SetLength(Buffer, BufSize);

  while not FS_Eof(SSSFile) do
  begin
    BytesRead := FS_BlockRead(SSSFile, Buffer[0], BufSize);
    if (BytesRead < BufSize) and not FS_Eof(SSSFile) then
    begin
      Finalize(Buffer);
      FS_CloseFile(SSSFile);
      CloseFile(SMKFile);
      Exit
    end;

    BlockWrite(SMKFile, Buffer[0], BytesRead, BytesWritten);
    if BytesWritten < BytesRead then
    begin
      Finalize(Buffer);
      FS_CloseFile(SSSFile);
      CloseFile(SMKFile);
      Exit
    end;

    SSSCallback(FS_FilePos(SSSFile) / FS_FileSize(SSSFile))
  end;

  Finalize(Buffer);
  FS_CloseFile(SSSFile);
  CloseFile(SMKFile);

  Result := True
end;

end.
