{ File   : SplWait.pas
  Author : Deniz Oezmen
  Created: 2006-11-03
  Changed: 2008-01-07

  TLJView Splash screen control.
}
unit SplWait;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TSplashWaitForm = class(TForm)
    BorderPanel: TPanel;
    ContentPanel: TPanel;
    MsgPanel: TPanel;
    MsgLabel: TLabel;
    SplashImage: TImage;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private-Deklarationen }
  public
    procedure BlendUp;
  end;

var
  SplashWaitForm: TSplashWaitForm;

implementation

{$R *.dfm}

var
  BlendUpInProgress  : Boolean = False;
  BlendDownInProgress: Boolean = False;

function BlendUpThreaded(Dummy: Pointer): Integer;
var
  i: Longint;
begin
  for i := 0 to 25 do
  begin
    SplashWaitForm.AlphaBlendValue := i * 10;
    Sleep(5);
    Application.ProcessMessages
  end;
  SplashWaitForm.AlphaBlendValue := 255;

  BlendUpInProgress := False;

  Result := 0
end;

function BlendDownThreaded(Dummy: Pointer): Integer;
var
  i: Byte;
begin
  for i := 25 downto 0 do
  begin
    SplashWaitForm.AlphaBlendValue := i * 10;
    Sleep(5);
    Application.ProcessMessages
  end;

  BlendDownInProgress := False;

  Result := 0
end;

procedure TSplashWaitForm.BlendUp;
var
  ThreadID: Cardinal;
begin
  BlendUpInProgress := True;

  if BeginThread(nil, 0, BlendUpThreaded, nil, 0, ThreadID) = 0 then
  begin
    SplashWaitForm.AlphaBlendValue := 255;

    BlendUpInProgress := False
  end
end;

procedure TSplashWaitForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
var
  ThreadID: Cardinal;
begin
  repeat
  until not BlendUpInProgress;

  BlendDownInProgress := True;

  if BeginThread(nil, 0, BlendDownThreaded, nil, 0, ThreadID) = 0 then
    BlendDownInProgress := False;

  repeat
  until not BlendDownInProgress
end;

end.
